



















var nTestsRun = 0;
var nPassed = 0, nRTE = 0;	
var nFailed = 0;
function PassTest() { nTestsRun++; nPassed++; }
function FailTest(m) { OutputMessage("Line( " + 16 + " ) : " + m); nTestsRun++; nFailed++; }









function CheckExpr(e, l, s) {
	nTestsRun++;
	var failed = ( ! (e) );
	if( failed ) {
		nFailed++;
		OutputMessage(l + " : " + s);
		}
	else {
		nPassed++;
		}
	return( failed );
	}
function FinalResult() {
	OutputMessage("Total tests : " + nTestsRun);
	OutputMessage("Passed " + nPassed + " test" + ((nPassed != 1) ? 's' : ""));
	if(nRTE != 0) OutputMessage("Run Time Exceptions " + nRTE + " test" + ((nRTE != 1) ? 's' : ""));
	OutputMessage("Failed " + nFailed + " test" + ((nFailed != 1) ? 's' : ""));
	}




var hexDigits = "0123456789ABCDEF";

function thmToHex(i)
{
	var res = "";

	do {
		var fourBits = i & 0xf;
		i >>>= 4;
		c = hexDigits.charAt(fourBits);
		res = c + res;
		}
	while(i != 0);
	return(res);
}

function thmDecodeError(e)
{
	thmMessage(thmToHex(e.number >>> 16) 
				+ ":" 
				+ (e.number & 0xffff) 
				+ " : "
				+ e.name
				+ " : "
				+ e.description
				);
	CheckExpr(e.description == e.message, 74, "e.description == e.message");
}

function thmDecodeObject(o)
{
	typeof(o);
	thmMessage(o.toString());
	for(i in o) {
		thmMessage("-- " + i + " : " + o[i]);
		}
	thmMessage("");
}

function thmDecodeRE(re)
{
thmMessage("RE.input : " + re.input);
thmMessage("RE.index : " + re.index);
thmMessage("RE.lastIndex : " + re.lastIndex);
thmMessage("RE.lastMatch : " + re.lastMatch);
thmMessage("RE.lastParen : " + re.lastParen);
thmMessage("RE.leftContext : " + re.leftContext);
thmMessage("RE.rightContext : " + re.rightContext);
thmMessage("RE.$1 : " + re.$1);
thmMessage("RE.$2 : " + re.$2);
thmMessage("RE.$3 : " + re.$3);
thmMessage("RE.$4 : " + re.$4);
thmMessage("RE.$5 : " + re.$5);
thmMessage("RE.$6 : " + re.$6);
thmMessage("RE.$7 : " + re.$7);
thmMessage("RE.$8 : " + re.$8);
thmMessage("RE.$9 : " + re.$9);
}












function OutputMessage(m)
{

	println(m);



}








function thmMessage(m)
{
	OutputMessage(m);
}




function thmTrace(f, m)
{
	OutputMessage(thmGetFunctionName(f) + m);
}




function thmInFunction(f)
{
	thmTrace(f, " : entering");
}




function thmOutFunction(f)
{
	thmTrace(f, " : leaving");
}



function thmGetFunctionName(f)
{
	if(f == null) {
		return("Script Engine");
	}
	var re = new RegExp("^function ([A-Za-z0-9]+)","ig");
	var ar = re.exec(f);
	var fn = RegExp.$1;
	return(fn);
}
































var	completed =	false;
var	testcases;
var tc = 0;

SECTION	= "";
VERSION	= "";
BUGNUMBER =	"";




var	GLOBAL = "[object global]";
var PASSED = " PASSED!"
var FAILED = " FAILED! expected: ";

var	DEBUG =	false;









function TestCaseObject(l, n, d, e,	a )	{
	this.name		 = n;
	this.description = "Line( " + l + " ) : " + d;
	this.expect		 = e;
	this.actual		 = a;
	this.passed		 = true;
	this.reason		 = "";
	this.bugnumber	  =	BUGNUMBER;
	if(e === "error") {
		this.passed	= true;
		}
	else {
		this.passed	= getTestCaseResult( this.expect, this.actual );
		nTestsRun++;
		if( this.passed ) {
			nPassed++;
			}
		else {
			nFailed++;
			}
		}
}


























function startTest() {


























    testcases = new Array();
    tc = 0;
}





function AddTestCase( description, expect, actual ) {
    testcases[tc++] = new TestCaseObject(134, SECTION,description,expect,actual);
}

function test(toEval) {
    for ( tc=0; tc < testcases.length; tc++ ) {
		var oldResult = testcases[tc].passed;
		var reason = "";

        if(arguments.length != 0) { 
			try { testcases[tc].actual = eval( testcases[tc].actual ); }
			catch(e) { thmDecodeError(e); nRTE++; if(testcases[tc].expect === "error") testcases[tc].actual = "error"; }
			if(typeof(arguments[0]) == "string") {
				testcases[tc].reason += arguments[0];
				reason = arguments[0];
				}
			}
        testcases[tc].passed = writeTestCaseResult(
                            testcases[tc].expect,
                            testcases[tc].actual,
                            testcases[tc].description +" = "+ testcases[tc].actual + reason);
		if(oldResult != testcases[tc].passed) {
			if(oldResult) {
				nFailed++; nPassed--;
				}
			else {
				nFailed--; nPassed++;
				}
			}
    }
    stopTest();
    return ( testcases );
}





function getTestCaseResult(	expect,	actual ) {
	
	
		if ( actual	!= actual )	{
			if ( typeof	actual == "object" ) {
				actual = "NaN object";
			} else {
				actual = "NaN number";
			}
		}
		if ( expect	!= expect )	{
			if ( typeof	expect == "object" ) {
				expect = "NaN object";
			} else {
				expect = "NaN number";
			}
		}

		var	passed = ( expect == actual	) ?	true : false;

	
	
		if (	!passed
				&& typeof(actual) == "number"
				&& typeof(expect) == "number"
			) {
				if ( Math.abs(actual-expect) < 0.0000001 ) {
					passed = true;
				}
		}

	
		if ( typeof(expect)	!= typeof(actual) )	{
			passed = false;
		}

		return passed;
}








function writeTestCaseResult( expect, actual, string ) {
		var	passed = getTestCaseResult(	expect,	actual );
		writeFormattedResult( expect, actual, string, passed );
		return passed;
}
function writeFormattedResult( expect, actual, string, passed ) {
        var s = string ;
        s += ( passed ) ? PASSED : FAILED + expect;
        if( ! passed ) writeLineToLog( s);
        return passed;
}
function writeLineToLog( string	) {
	OutputMessage( string );
}
function writeHeaderToLog( string )	{
	OutputMessage( string );
}








function stopTest()	{
 	var gc;
	if ( gc != undefined ) {
		gc();
	}
}






function getFailedCases() {
  for (	var	i =	0; i < testcases.length; i++ ) {
	 if	( !	testcases[i].passed	) {
		OutputMessage( testcases[i].description	+" = " +testcases[i].actual	+" expected: "+	testcases[i].expect	);
	 }
  }
}
 



var	msPerDay =			86400000;
var	HoursPerDay	=		24;
var	MinutesPerHour =	60;
var	SecondsPerMinute =	60;
var	msPerSecond	=		1000;
var	msPerMinute	=		60000;		
var	msPerHour =			3600000;	
var             TZ_DIFF	= getTimeZoneDiff();  
var             TZ_PST = -8;  
var             PST_DIFF = TZ_DIFF - TZ_PST;  
var	TIME_1970	 = 0;
var	TIME_2000	 = 946684800000;
var	TIME_1900	 = -2208988800000;








function getTimeZoneDiff()
{
  return -((new Date(2000, 1, 1)).getTimezoneOffset())/60;
}






function adjustResultArray(ResultArray, msMode)
{
  
  if (!PST_DIFF) {return;} 

  











 
  if (msMode)
  {
    
    
    var t = ResultArray[TIME]  +  TZ_DIFF*msPerHour;

    
    ResultArray[HOURS] = HourFromTime(t); 
    ResultArray[DAY] = WeekDay(t);
    ResultArray[DATE] = DateFromTime(t);
    ResultArray[MONTH] = MonthFromTime(t);
    ResultArray[YEAR] = YearFromTime(t);  
  }
  else
  {
    
    
    var t = ResultArray[TIME]  -  PST_DIFF*msPerHour;

    
    ResultArray[TIME] = t;
    ResultArray[UTC_HOURS] = HourFromTime(t); 
    ResultArray[UTC_DAY] = WeekDay(t);
    ResultArray[UTC_DATE] = DateFromTime(t);
    ResultArray[UTC_MONTH] = MonthFromTime(t);
    ResultArray[UTC_YEAR] = YearFromTime(t);
  }
}


function Day( t	) {
	return ( Math.floor(t/msPerDay ) );
}
function DaysInYear( y ) {
	if ( y % 4 != 0	) {
		return 365;
	}
	if ( (y	% 4	== 0) && (y	% 100 != 0)	) {
		return 366;
	}
	if ( (y	% 100 == 0)	&&	(y % 400 !=	0) ) {
		return 365;
	}
	if ( (y	% 400 == 0)	){
		return 366;
	} else {
		return "ERROR: DaysInYear("	+ y	+ ") case not covered";
	}
}
function TimeInYear( y ) {
	return ( DaysInYear(y) * msPerDay );
}
function DayNumber(	t )	{
	return ( Math.floor( t / msPerDay )	);
}
function TimeWithinDay(	t )	{
	if ( t < 0 ) {
		return ( (t	% msPerDay)	+ msPerDay );
	} else {
		return ( t % msPerDay );
	}
}
function YearNumber( t ) {
}
function TimeFromYear( y ) {
	return ( msPerDay *	DayFromYear(y) );
}
function DayFromYear( y	) {
	return (	365*(y-1970) +
				Math.floor((y-1969)/4) -
				Math.floor((y-1901)/100) +
				Math.floor((y-1601)/400) );
}
function InLeapYear( t ) {
	if ( DaysInYear(YearFromTime(t)) ==	365	) {
		return 0;
	}
	if ( DaysInYear(YearFromTime(t)) ==	366	) {
		return 1;
	} else {
		return "ERROR:	DayFromYear("+y+") case	not	covered";
	}
}
function YearFromTime( t ) {
	t =	Number(	t );
	var	sign = ( t < 0 ) ? -1 :	1;
	var	year = ( sign <	0 )	? 1969 : 1970;
	for	(	var	timeToTimeZero = t;	;  ) {
	
		timeToTimeZero -= sign * TimeInYear(year)

	
		if ( sign <	0 )	{
			if ( sign *	timeToTimeZero <= 0	) {
				break;
			} else {
				year +=	sign;
			}
		} else {
			if ( sign *	timeToTimeZero < 0 ) {
				break;
			} else {
				year +=	sign;
			}
		}
	}
	return ( year );
}
function MonthFromTime(	t )	{
	
	var	day	= DayWithinYear( t );
	var	leap = InLeapYear(t);

	if ( (0	<= day)	&& (day	< 31) )	{
		return 0;
	}
	if ( (31 <=	day) &&	(day < (59+leap)) )	{
		return 1;
	}
	if ( ((59+leap)	<= day)	&& (day	< (90+leap)) ) {
		return 2;
	}
	if ( ((90+leap)	<= day)	&& (day	< (120+leap)) )	{
		return 3;
	}
	if ( ((120+leap) <=	day) &&	(day < (151+leap)) ) {
		return 4;
	}
	if ( ((151+leap) <=	day) &&	(day < (181+leap)) ) {
		return 5;
	}
	if ( ((181+leap) <=	day) &&	(day < (212+leap)) ) {
		return 6;
	}
	if ( ((212+leap) <=	day) &&	(day < (243+leap)) ) {
		return 7;
	}
	if ( ((243+leap) <=	day) &&	(day < (273+leap)) ) {
		return 8;
	}
	if ( ((273+leap) <=	day) &&	(day < (304+leap)) ) {
		return 9;
	}
	if ( ((304+leap) <=	day) &&	(day < (334+leap)) ) {
		return 10;
	}
	if ( ((334+leap) <=	day) &&	(day < (365+leap)) ) {
		return 11;
	} else {
		return "ERROR:	MonthFromTime("+t+") not known";
	}
}
function DayWithinYear(	t )	{
		return(	Day(t) - DayFromYear(YearFromTime(t)));
}
function DateFromTime( t ) {
	var	day	= DayWithinYear(t);
	var	month =	MonthFromTime(t);

	if ( month == 0	) {
		return ( day + 1 );
	}
	if ( month == 1	) {
		return ( day - 30 );
	}
	if ( month == 2	) {
		return ( day - 58 -	InLeapYear(t) );
	}
	if ( month == 3	) {
		return ( day - 89 -	InLeapYear(t));
	}
	if ( month == 4	) {
		return ( day - 119 - InLeapYear(t));
	}
	if ( month == 5	) {
		return ( day - 150-	InLeapYear(t));
	}
	if ( month == 6	) {
		return ( day - 180-	InLeapYear(t));
	}
	if ( month == 7	) {
		return ( day - 211-	InLeapYear(t));
	}
	if ( month == 8	) {
		return ( day - 242-	InLeapYear(t));
	}
	if ( month == 9	) {
		return ( day - 272-	InLeapYear(t));
	}
	if ( month == 10 ) {
		return ( day - 303-	InLeapYear(t));
	}
	if ( month == 11 ) {
		return ( day - 333-	InLeapYear(t));
	}

	return ("ERROR:	 DateFromTime("+t+") not known"	);
}
function WeekDay( t	) {
	var	weekday	= (Day(t)+4) % 7;
	return(	weekday	< 0	? 7	+ weekday :	weekday	);
}



function HourFromTime( t ) {
	var	h =	Math.floor(	t /	msPerHour )	% HoursPerDay;
	return ( (h<0) ? HoursPerDay + h : h  );
}
function MinFromTime( t	) {
	var	min	= Math.floor( t	/ msPerMinute )	% MinutesPerHour;
	return(	( min <	0 )	? MinutesPerHour + min : min  );
}
function SecFromTime( t	) {
	var	sec	= Math.floor( t	/ msPerSecond )	% SecondsPerMinute;
	return ( (sec <	0 )	? SecondsPerMinute + sec : sec );
}
function msFromTime( t ) {
	var	ms = t % msPerSecond;
	return ( (ms < 0 ) ? msPerSecond + ms :	ms );
}
function LocalTZA()	{
	return ( TZ_DIFF * msPerHour );
}
function UTC( t	) {
	return ( t - LocalTZA()	- DaylightSavingTA(t - LocalTZA()) );
}

function DaylightSavingTA( t ) {
	t =	t -	LocalTZA();

	var	dst_start =	GetFirstSundayInApril(t) + 2*msPerHour;
	var	dst_end	  =	GetLastSundayInOctober(t)+ 2*msPerHour;

	if ( t >= dst_start	&& t < dst_end ) {
		return msPerHour;
	} else {
		return 0;
	}

	
	

	OutputMessage( new Date( UTC(dst_start + LocalTZA())) );

	return UTC(dst_start  +	LocalTZA());
}
function GetFirstSundayInApril(	t )	{
	var	year = YearFromTime(t);
	var	leap = InLeapYear(t);

	var	april =	TimeFromYear(year) + TimeInMonth(0,	leap) +	TimeInMonth(1,leap)	+
	TimeInMonth(2,leap);

	for	( var first_sunday = april;	WeekDay(first_sunday) >	0;
		first_sunday +=	msPerDay )
	{
		;
	}

	return first_sunday;
}
function GetLastSundayInOctober( t ) {
	var	year = YearFromTime(t);
	var	leap = InLeapYear(t);

	for	( var oct =	TimeFromYear(year),	m =	0; m < 9; m++ )	{
		oct	+= TimeInMonth(m, leap);
	}
	for	( var last_sunday =	oct	+ 30*msPerDay; WeekDay(last_sunday)	> 0;
		last_sunday	-= msPerDay	)
	{
		;
	}
	return last_sunday;
}
function LocalTime(	t )	{
	return ( t + LocalTZA()	+ DaylightSavingTA(t) );
}
function MakeTime( hour, min, sec, ms )	{
	if ( isNaN(	hour ) || isNaN( min ) || isNaN( sec ) || isNaN( ms	) )	{
		return Number.NaN;
	}

	hour = ToInteger(hour);
	min	 = ToInteger( min);
	sec	 = ToInteger( sec);
	ms	 = ToInteger( ms );

	return(	(hour*msPerHour) + (min*msPerMinute) +
			(sec*msPerSecond) +	ms );
}
function MakeDay( year,	month, date	) {
	if ( isNaN(year) ||	isNaN(month) ||	isNaN(date)	) {
		return Number.NaN;
	}
	year = ToInteger(year);
	month =	ToInteger(month);
	date = ToInteger(date );

	var	sign = ( year <	1970 ) ? -1	: 1;
	var	t =	   ( year <	1970 ) ? 1 :  0;
	var	y =	   ( year <	1970 ) ? 1969 :	1970;

	var	result5	= year + Math.floor( month/12 );
	var	result6	= month	% 12;

	if ( year <	1970 ) {
	   for ( y = 1969; y >=	year; y	+= sign	) {
		 t += sign * TimeInYear(y);
	   }
	} else {
		for	( y	= 1970 ; y < year; y +=	sign ) {
			t += sign *	TimeInYear(y);
		}
	}

	var	leap = InLeapYear( t );

	for	( var m	= 0; m < month;	m++	) {
		t += TimeInMonth( m, leap );
	}

	if ( YearFromTime(t) !=	result5	) {
		return Number.NaN;
	}
	if ( MonthFromTime(t) != result6 ) {
		return Number.NaN;
	}
	if ( DateFromTime(t) !=	1 )	{
		return Number.NaN;
	}

	return ( (Day(t)) +	date - 1 );
}
function TimeInMonth( month, leap )	{
	
	
	

	if ( month == 3	|| month ==	5 || month == 8	|| month ==	10 ) {
		return ( 30*msPerDay );
	}

	
	if ( month == 0	|| month ==	2 || month == 4	|| month ==	6 ||
		 month == 7	|| month ==	9 || month == 11 ) {
		return ( 31*msPerDay );
	 }

	
	return ( (leap == 0) ? 28*msPerDay : 29*msPerDay );
}
function MakeDate( day,	time ) {
	if (	day	== Number.POSITIVE_INFINITY	||
			day	== Number.NEGATIVE_INFINITY	||
			day	== Number.NaN )	{
		return Number.NaN;
	}
	if (	time ==	Number.POSITIVE_INFINITY ||
			time ==	Number.POSITIVE_INFINITY ||
			day	== Number.NaN) {
		return Number.NaN;
	}
	return ( day * msPerDay	) +	time;
}
function TimeClip( t ) {
	if ( isNaN(	t )	) {
		return ( Number.NaN	);
	}
	if ( Math.abs( t ) > 8.64e15 ) {
		return ( Number.NaN	);
	}

	return ( ToInteger(	t )	);
}
function ToInteger(	t )	{
	t =	Number(	t );

	if ( isNaN(	t )	){
		return ( Number.NaN	);
	}
	if ( t == 0	|| t ==	-0 ||
		 t == Number.POSITIVE_INFINITY || t	== Number.NEGATIVE_INFINITY	) {
		 return	0;
	}

	var	sign = ( t < 0 ) ? -1 :	1;

	return ( sign *	Math.floor(	Math.abs( t	) )	);
}
function Enumerate ( o ) {
	var	p;
	for	( p	in o ) {
		OutputMessage( p +": " + o[p] );
	}
}



function GetContext() {
	return Packages.com.netscape.javascript.Context.getCurrentContext();
}
function OptLevel( i ) {
	i =	Number(i);
	var	cx = GetContext();
	cx.setOptimizationLevel(i);
}






























































    var SECTION = "15.1.2.3-2";
    var VERSION = "ECMA_1";
    startTest();

    var BUGNUMBER = "77391";

    var testcases = getTestCases();

    writeHeaderToLog( SECTION + " parseFloat(string)");
    test();

function getTestCases() {
    var array = new Array();
    var item = 0;

    array[item++] = new TestCaseObject(76, SECTION,"parseFloat(true)",Number.NaN,parseFloat(true));
    array[item++] = new TestCaseObject(77, SECTION,"parseFloat(false)",Number.NaN,parseFloat(false));
    array[item++] = new TestCaseObject(78, SECTION,"parseFloat('string')",Number.NaN,parseFloat("string"));

    array[item++] = new TestCaseObject(80, SECTION,"parseFloat('     Infinity')",Number.POSITIVE_INFINITY,parseFloat("Infinity"));


    array[item++] = new TestCaseObject(83, SECTION,"parseFloat('          0')",0,parseFloat("          0"));
    array[item++] = new TestCaseObject(84, SECTION,"parseFloat('          -0')",-0,parseFloat("          -0"));
    array[item++] = new TestCaseObject(85, SECTION,"parseFloat('          +0')",0,parseFloat("          +0"));

    array[item++] = new TestCaseObject(87, SECTION,"parseFloat('          1')",1,parseFloat("          1"));
    array[item++] = new TestCaseObject(88, SECTION,"parseFloat('          -1')",-1,parseFloat("          -1"));
    array[item++] = new TestCaseObject(89, SECTION,"parseFloat('          +1')",1,parseFloat("          +1"));

    array[item++] = new TestCaseObject(91, SECTION,"parseFloat('          2')",2,parseFloat("          2"));
    array[item++] = new TestCaseObject(92, SECTION,"parseFloat('          -2')",-2,parseFloat("          -2"));
    array[item++] = new TestCaseObject(93, SECTION,"parseFloat('          +2')",2,parseFloat("          +2"));

    array[item++] = new TestCaseObject(95, SECTION,"parseFloat('          3')",3,parseFloat("          3"));
    array[item++] = new TestCaseObject(96, SECTION,"parseFloat('          -3')",-3,parseFloat("          -3"));
    array[item++] = new TestCaseObject(97, SECTION,"parseFloat('          +3')",3,parseFloat("          +3"));

    array[item++] = new TestCaseObject(99, SECTION,"parseFloat('          4')",4,parseFloat("          4"));
    array[item++] = new TestCaseObject(100, SECTION,"parseFloat('          -4')",-4,parseFloat("          -4"));
    array[item++] = new TestCaseObject(101, SECTION,"parseFloat('          +4')",4,parseFloat("          +4"));

    array[item++] = new TestCaseObject(103, SECTION,"parseFloat('          5')",5,parseFloat("          5"));
    array[item++] = new TestCaseObject(104, SECTION,"parseFloat('          -5')",-5,parseFloat("          -5"));
    array[item++] = new TestCaseObject(105, SECTION,"parseFloat('          +5')",5,parseFloat("          +5"));

    array[item++] = new TestCaseObject(107, SECTION,"parseFloat('          6')",6,parseFloat("          6"));
    array[item++] = new TestCaseObject(108, SECTION,"parseFloat('          -6')",-6,parseFloat("          -6"));
    array[item++] = new TestCaseObject(109, SECTION,"parseFloat('          +6')",6,parseFloat("          +6"));

    array[item++] = new TestCaseObject(111, SECTION,"parseFloat('          7')",7,parseFloat("          7"));
    array[item++] = new TestCaseObject(112, SECTION,"parseFloat('          -7')",-7,parseFloat("          -7"));
    array[item++] = new TestCaseObject(113, SECTION,"parseFloat('          +7')",7,parseFloat("          +7"));

    array[item++] = new TestCaseObject(115, SECTION,"parseFloat('          8')",8,parseFloat("          8"));
    array[item++] = new TestCaseObject(116, SECTION,"parseFloat('          -8')",-8,parseFloat("          -8"));
    array[item++] = new TestCaseObject(117, SECTION,"parseFloat('          +8')",8,parseFloat("          +8"));

    array[item++] = new TestCaseObject(119, SECTION,"parseFloat('          9')",9,parseFloat("          9"));
    array[item++] = new TestCaseObject(120, SECTION,"parseFloat('          -9')",-9,parseFloat("          -9"));
    array[item++] = new TestCaseObject(121, SECTION,"parseFloat('          +9')",9,parseFloat("          +9"));

    array[item++] = new TestCaseObject(123, SECTION,"parseFloat('          3.14159')",3.14159,parseFloat("          3.14159"));
    array[item++] = new TestCaseObject(124, SECTION,"parseFloat('          -3.14159')",-3.14159,parseFloat("          -3.14159"));
    array[item++] = new TestCaseObject(125, SECTION,"parseFloat('          +3.14159')",3.14159,parseFloat("          +3.14159"));

    array[item++] = new TestCaseObject(127, SECTION,"parseFloat('          3.')",3,parseFloat("          3."));
    array[item++] = new TestCaseObject(128, SECTION,"parseFloat('          -3.')",-3,parseFloat("          -3."));
    array[item++] = new TestCaseObject(129, SECTION,"parseFloat('          +3.')",3,parseFloat("          +3."));

    array[item++] = new TestCaseObject(131, SECTION,"parseFloat('          3.e1')",30,parseFloat("          3.e1"));
    array[item++] = new TestCaseObject(132, SECTION,"parseFloat('          -3.e1')",-30,parseFloat("          -3.e1"));
    array[item++] = new TestCaseObject(133, SECTION,"parseFloat('          +3.e1')",30,parseFloat("          +3.e1"));

    array[item++] = new TestCaseObject(135, SECTION,"parseFloat('          3.e+1')",30,parseFloat("          3.e+1"));
    array[item++] = new TestCaseObject(136, SECTION,"parseFloat('          -3.e+1')",-30,parseFloat("          -3.e+1"));
    array[item++] = new TestCaseObject(137, SECTION,"parseFloat('          +3.e+1')",30,parseFloat("          +3.e+1"));

    array[item++] = new TestCaseObject(139, SECTION,"parseFloat('          3.e-1')",.30,parseFloat("          3.e-1"));
    array[item++] = new TestCaseObject(140, SECTION,"parseFloat('          -3.e-1')",-.30,parseFloat("          -3.e-1"));
    array[item++] = new TestCaseObject(141, SECTION,"parseFloat('          +3.e-1')",.30,parseFloat("          +3.e-1"));

    

    array[item++] = new TestCaseObject(145, SECTION,"parseFloat('          .00001')",0.00001,parseFloat("          .00001"));
    array[item++] = new TestCaseObject(146, SECTION,"parseFloat('          +.00001')",0.00001,parseFloat("          +.00001"));
    array[item++] = new TestCaseObject(147, SECTION,"parseFloat('          -0.0001')",-0.00001,parseFloat("          -.00001"));

    array[item++] = new TestCaseObject(149, SECTION,"parseFloat('          .01e2')",1,parseFloat("          .01e2"));
    array[item++] = new TestCaseObject(150, SECTION,"parseFloat('          +.01e2')",1,parseFloat("          +.01e2"));
    array[item++] = new TestCaseObject(151, SECTION,"parseFloat('          -.01e2')",-1,parseFloat("          -.01e2"));

    array[item++] = new TestCaseObject(153, SECTION,"parseFloat('          .01e+2')",1,parseFloat("          .01e+2"));
    array[item++] = new TestCaseObject(154, SECTION,"parseFloat('          +.01e+2')",1,parseFloat("          +.01e+2"));
    array[item++] = new TestCaseObject(155, SECTION,"parseFloat('          -.01e+2')",-1,parseFloat("          -.01e+2"));

    array[item++] = new TestCaseObject(157, SECTION,"parseFloat('          .01e-2')",0.0001,parseFloat("          .01e-2"));
    array[item++] = new TestCaseObject(158, SECTION,"parseFloat('          +.01e-2')",0.0001,parseFloat("          +.01e-2"));
    array[item++] = new TestCaseObject(159, SECTION,"parseFloat('          -.01e-2')",-0.0001,parseFloat("          -.01e-2"));

    

    array[item++] = new TestCaseObject(163, SECTION,"parseFloat('          1234e5')",123400000,parseFloat("          1234e5"));
    array[item++] = new TestCaseObject(164, SECTION,"parseFloat('          +1234e5')",123400000,parseFloat("          +1234e5"));
    array[item++] = new TestCaseObject(165, SECTION,"parseFloat('          -1234e5')",-123400000,parseFloat("          -1234e5"));

    array[item++] = new TestCaseObject(167, SECTION,"parseFloat('          1234e+5')",123400000,parseFloat("          1234e+5"));
    array[item++] = new TestCaseObject(168, SECTION,"parseFloat('          +1234e+5')",123400000,parseFloat("          +1234e+5"));
    array[item++] = new TestCaseObject(169, SECTION,"parseFloat('          -1234e+5')",-123400000,parseFloat("          -1234e+5"));

    array[item++] = new TestCaseObject(171, SECTION,"parseFloat('          1234e-5')",0.01234,parseFloat("          1234e-5"));
    array[item++] = new TestCaseObject(172, SECTION,"parseFloat('          +1234e-5')",0.01234,parseFloat("          +1234e-5"));
    array[item++] = new TestCaseObject(173, SECTION,"parseFloat('          -1234e-5')",-0.01234,parseFloat("          -1234e-5"));


    array[item++] = new TestCaseObject(176, SECTION,"parseFloat('          .01E2')",1,parseFloat("          .01E2"));
    array[item++] = new TestCaseObject(177, SECTION,"parseFloat('          +.01E2')",1,parseFloat("          +.01E2"));
    array[item++] = new TestCaseObject(178, SECTION,"parseFloat('          -.01E2')",-1,parseFloat("          -.01E2"));

    array[item++] = new TestCaseObject(180, SECTION,"parseFloat('          .01E+2')",1,parseFloat("          .01E+2"));
    array[item++] = new TestCaseObject(181, SECTION,"parseFloat('          +.01E+2')",1,parseFloat("          +.01E+2"));
    array[item++] = new TestCaseObject(182, SECTION,"parseFloat('          -.01E+2')",-1,parseFloat("          -.01E+2"));

    array[item++] = new TestCaseObject(184, SECTION,"parseFloat('          .01E-2')",0.0001,parseFloat("          .01E-2"));
    array[item++] = new TestCaseObject(185, SECTION,"parseFloat('          +.01E-2')",0.0001,parseFloat("          +.01E-2"));
    array[item++] = new TestCaseObject(186, SECTION,"parseFloat('          -.01E-2')",-0.0001,parseFloat("          -.01E-2"));

    
    array[item++] = new TestCaseObject(189, SECTION,"parseFloat('          1234E5')",123400000,parseFloat("          1234E5"));
    array[item++] = new TestCaseObject(190, SECTION,"parseFloat('          +1234E5')",123400000,parseFloat("          +1234E5"));
    array[item++] = new TestCaseObject(191, SECTION,"parseFloat('          -1234E5')",-123400000,parseFloat("          -1234E5"));

    array[item++] = new TestCaseObject(193, SECTION,"parseFloat('          1234E+5')",123400000,parseFloat("          1234E+5"));
    array[item++] = new TestCaseObject(194, SECTION,"parseFloat('          +1234E+5')",123400000,parseFloat("          +1234E+5"));
    array[item++] = new TestCaseObject(195, SECTION,"parseFloat('          -1234E+5')",-123400000,parseFloat("          -1234E+5"));

    array[item++] = new TestCaseObject(197, SECTION,"parseFloat('          1234E-5')",0.01234,parseFloat("          1234E-5"));
    array[item++] = new TestCaseObject(198, SECTION,"parseFloat('          +1234E-5')",0.01234,parseFloat("          +1234E-5"));
    array[item++] = new TestCaseObject(199, SECTION,"parseFloat('          -1234E-5')",-0.01234,parseFloat("          -1234E-5"));


    

    array[item++] = new TestCaseObject(204, SECTION,"parseFloat('          0x0')",0,parseFloat("          0x0"));
    array[item++] = new TestCaseObject(205, SECTION,"parseFloat('          0x1')",0,parseFloat("          0x1"));
    array[item++] = new TestCaseObject(206, SECTION,"parseFloat('          0x2')",0,parseFloat("          0x2"));
    array[item++] = new TestCaseObject(207, SECTION,"parseFloat('          0x3')",0,parseFloat("          0x3"));
    array[item++] = new TestCaseObject(208, SECTION,"parseFloat('          0x4')",0,parseFloat("          0x4"));
    array[item++] = new TestCaseObject(209, SECTION,"parseFloat('          0x5')",0,parseFloat("          0x5"));
    array[item++] = new TestCaseObject(210, SECTION,"parseFloat('          0x6')",0,parseFloat("          0x6"));
    array[item++] = new TestCaseObject(211, SECTION,"parseFloat('          0x7')",0,parseFloat("          0x7"));
    array[item++] = new TestCaseObject(212, SECTION,"parseFloat('          0x8')",0,parseFloat("          0x8"));
    array[item++] = new TestCaseObject(213, SECTION,"parseFloat('          0x9')",0,parseFloat("          0x9"));
    array[item++] = new TestCaseObject(214, SECTION,"parseFloat('          0xa')",0,parseFloat("          0xa"));
    array[item++] = new TestCaseObject(215, SECTION,"parseFloat('          0xb')",0,parseFloat("          0xb"));
    array[item++] = new TestCaseObject(216, SECTION,"parseFloat('          0xc')",0,parseFloat("          0xc"));
    array[item++] = new TestCaseObject(217, SECTION,"parseFloat('          0xd')",0,parseFloat("          0xd"));
    array[item++] = new TestCaseObject(218, SECTION,"parseFloat('          0xe')",0,parseFloat("          0xe"));
    array[item++] = new TestCaseObject(219, SECTION,"parseFloat('          0xf')",0,parseFloat("          0xf"));
    array[item++] = new TestCaseObject(220, SECTION,"parseFloat('          0xA')",0,parseFloat("          0xA"));
    array[item++] = new TestCaseObject(221, SECTION,"parseFloat('          0xB')",0,parseFloat("          0xB"));
    array[item++] = new TestCaseObject(222, SECTION,"parseFloat('          0xC')",0,parseFloat("          0xC"));
    array[item++] = new TestCaseObject(223, SECTION,"parseFloat('          0xD')",0,parseFloat("          0xD"));
    array[item++] = new TestCaseObject(224, SECTION,"parseFloat('          0xE')",0,parseFloat("          0xE"));
    array[item++] = new TestCaseObject(225, SECTION,"parseFloat('          0xF')",0,parseFloat("          0xF"));

    array[item++] = new TestCaseObject(227, SECTION,"parseFloat('          0X0')",0,parseFloat("          0X0"));
    array[item++] = new TestCaseObject(228, SECTION,"parseFloat('          0X1')",0,parseFloat("          0X1"));
    array[item++] = new TestCaseObject(229, SECTION,"parseFloat('          0X2')",0,parseFloat("          0X2"));
    array[item++] = new TestCaseObject(230, SECTION,"parseFloat('          0X3')",0,parseFloat("          0X3"));
    array[item++] = new TestCaseObject(231, SECTION,"parseFloat('          0X4')",0,parseFloat("          0X4"));
    array[item++] = new TestCaseObject(232, SECTION,"parseFloat('          0X5')",0,parseFloat("          0X5"));
    array[item++] = new TestCaseObject(233, SECTION,"parseFloat('          0X6')",0,parseFloat("          0X6"));
    array[item++] = new TestCaseObject(234, SECTION,"parseFloat('          0X7')",0,parseFloat("          0X7"));
    array[item++] = new TestCaseObject(235, SECTION,"parseFloat('          0X8')",0,parseFloat("          0X8"));
    array[item++] = new TestCaseObject(236, SECTION,"parseFloat('          0X9')",0,parseFloat("          0X9"));
    array[item++] = new TestCaseObject(237, SECTION,"parseFloat('          0Xa')",0,parseFloat("          0Xa"));
    array[item++] = new TestCaseObject(238, SECTION,"parseFloat('          0Xb')",0,parseFloat("          0Xb"));
    array[item++] = new TestCaseObject(239, SECTION,"parseFloat('          0Xc')",0,parseFloat("          0Xc"));
    array[item++] = new TestCaseObject(240, SECTION,"parseFloat('          0Xd')",0,parseFloat("          0Xd"));
    array[item++] = new TestCaseObject(241, SECTION,"parseFloat('          0Xe')",0,parseFloat("          0Xe"));
    array[item++] = new TestCaseObject(242, SECTION,"parseFloat('          0Xf')",0,parseFloat("          0Xf"));
    array[item++] = new TestCaseObject(243, SECTION,"parseFloat('          0XA')",0,parseFloat("          0XA"));
    array[item++] = new TestCaseObject(244, SECTION,"parseFloat('          0XB')",0,parseFloat("          0XB"));
    array[item++] = new TestCaseObject(245, SECTION,"parseFloat('          0XC')",0,parseFloat("          0XC"));
    array[item++] = new TestCaseObject(246, SECTION,"parseFloat('          0XD')",0,parseFloat("          0XD"));
    array[item++] = new TestCaseObject(247, SECTION,"parseFloat('          0XE')",0,parseFloat("          0XE"));
    array[item++] = new TestCaseObject(248, SECTION,"parseFloat('          0XF')",0,parseFloat("          0XF"));

    

    array[item++] = new TestCaseObject(252, SECTION,"parseFloat('          00')",0,parseFloat("          00"));
    array[item++] = new TestCaseObject(253, SECTION,"parseFloat('          01')",1,parseFloat("          01"));
    array[item++] = new TestCaseObject(254, SECTION,"parseFloat('          02')",2,parseFloat("          02"));
    array[item++] = new TestCaseObject(255, SECTION,"parseFloat('          03')",3,parseFloat("          03"));
    array[item++] = new TestCaseObject(256, SECTION,"parseFloat('          04')",4,parseFloat("          04"));
    array[item++] = new TestCaseObject(257, SECTION,"parseFloat('          05')",5,parseFloat("          05"));
    array[item++] = new TestCaseObject(258, SECTION,"parseFloat('          06')",6,parseFloat("          06"));
    array[item++] = new TestCaseObject(259, SECTION,"parseFloat('          07')",7,parseFloat("          07"));
    array[item++] = new TestCaseObject(260, SECTION,"parseFloat('          010')",10,parseFloat("          010"));
    array[item++] = new TestCaseObject(261, SECTION,"parseFloat('          011')",11,parseFloat("          011"));

    

    array[item++] = new TestCaseObject(265, SECTION,"parseFloat('          001')",1,parseFloat("          001"));
    array[item++] = new TestCaseObject(266, SECTION,"parseFloat('          0001')",1,parseFloat("          0001"));

    

    array[item++] = new TestCaseObject(270, SECTION,"parseFloat(001)",1,parseFloat(001));
    array[item++] = new TestCaseObject(271, SECTION,"parseFloat(0001)",1,parseFloat(0001));

    
    array[item++] = new TestCaseObject(274, SECTION,"parseFloat( '                    '          +Math.PI+'          ')",Math.PI,parseFloat( '                    ' +Math.PI+'          '));
    array[item++] = new TestCaseObject(275, SECTION,"parseFloat( '                    '          +Math.LN2+'          ')",Math.LN2,parseFloat( '                    ' +Math.LN2+'          '));
    array[item++] = new TestCaseObject(276, SECTION,"parseFloat( '                    '          +Math.LN10+'          ')",Math.LN10,parseFloat( '                    ' +Math.LN10+'          '));
    array[item++] = new TestCaseObject(277, SECTION,"parseFloat( '                    '          +Math.LOG2E+'          ')",Math.LOG2E,parseFloat( '                    ' +Math.LOG2E+'          '));
    array[item++] = new TestCaseObject(278, SECTION,"parseFloat( '                    '          +Math.LOG10E+'          ')",Math.LOG10E,parseFloat( '                    ' +Math.LOG10E+'          '));
    array[item++] = new TestCaseObject(279, SECTION,"parseFloat( '                    '          +Math.SQRT2+'          ')",Math.SQRT2,parseFloat( '                    ' +Math.SQRT2+'          '));
    array[item++] = new TestCaseObject(280, SECTION,"parseFloat( '                    '          +Math.SQRT1_2+'          ')",Math.SQRT1_2,parseFloat( '                    ' +Math.SQRT1_2+'          '));


    return ( array );
}
function test( array ) {
    for ( tc=0; tc < testcases.length; tc++ ) {
        testcases[tc].passed = writeTestCaseResult(
                            testcases[tc].expect,
                            testcases[tc].actual,
                            testcases[tc].description +" = "+ testcases[tc].actual );

        testcases[tc].reason += ( testcases[tc].passed ) ? "" : "wrong value ";
    }
    stopTest();
    return ( testcases );
}
FinalResult();







