



















var nTestsRun = 0;
var nPassed = 0, nRTE = 0;	
var nFailed = 0;
function PassTest() { nTestsRun++; nPassed++; }
function FailTest(m) { OutputMessage("Line( " + 16 + " ) : " + m); nTestsRun++; nFailed++; }









function CheckExpr(e, l, s) {
	nTestsRun++;
	var failed = ( ! (e) );
	if( failed ) {
		nFailed++;
		OutputMessage(l + " : " + s);
		}
	else {
		nPassed++;
		}
	return( failed );
	}
function FinalResult() {
	OutputMessage("Total tests : " + nTestsRun);
	OutputMessage("Passed " + nPassed + " test" + ((nPassed != 1) ? 's' : ""));
	if(nRTE != 0) OutputMessage("Run Time Exceptions " + nRTE + " test" + ((nRTE != 1) ? 's' : ""));
	OutputMessage("Failed " + nFailed + " test" + ((nFailed != 1) ? 's' : ""));
	}




var hexDigits = "0123456789ABCDEF";

function thmToHex(i)
{
	var res = "";

	do {
		var fourBits = i & 0xf;
		i >>>= 4;
		c = hexDigits.charAt(fourBits);
		res = c + res;
		}
	while(i != 0);
	return(res);
}

function thmDecodeError(e)
{
	thmMessage(thmToHex(e.number >>> 16) 
				+ ":" 
				+ (e.number & 0xffff) 
				+ " : "
				+ e.name
				+ " : "
				+ e.description
				);
	CheckExpr(e.description == e.message, 74, "e.description == e.message");
}

function thmDecodeObject(o)
{
	typeof(o);
	thmMessage(o.toString());
	for(i in o) {
		thmMessage("-- " + i + " : " + o[i]);
		}
	thmMessage("");
}

function thmDecodeRE(re)
{
thmMessage("RE.input : " + re.input);
thmMessage("RE.index : " + re.index);
thmMessage("RE.lastIndex : " + re.lastIndex);
thmMessage("RE.lastMatch : " + re.lastMatch);
thmMessage("RE.lastParen : " + re.lastParen);
thmMessage("RE.leftContext : " + re.leftContext);
thmMessage("RE.rightContext : " + re.rightContext);
thmMessage("RE.$1 : " + re.$1);
thmMessage("RE.$2 : " + re.$2);
thmMessage("RE.$3 : " + re.$3);
thmMessage("RE.$4 : " + re.$4);
thmMessage("RE.$5 : " + re.$5);
thmMessage("RE.$6 : " + re.$6);
thmMessage("RE.$7 : " + re.$7);
thmMessage("RE.$8 : " + re.$8);
thmMessage("RE.$9 : " + re.$9);
}












function OutputMessage(m)
{

	println(m);



}








function thmMessage(m)
{
	OutputMessage(m);
}




function thmTrace(f, m)
{
	OutputMessage(thmGetFunctionName(f) + m);
}




function thmInFunction(f)
{
	thmTrace(f, " : entering");
}




function thmOutFunction(f)
{
	thmTrace(f, " : leaving");
}



function thmGetFunctionName(f)
{
	if(f == null) {
		return("Script Engine");
	}
	var re = new RegExp("^function ([A-Za-z0-9]+)","ig");
	var ar = re.exec(f);
	var fn = RegExp.$1;
	return(fn);
}
































var	completed =	false;
var	testcases;
var tc = 0;

SECTION	= "";
VERSION	= "";
BUGNUMBER =	"";




var	GLOBAL = "[object global]";
var PASSED = " PASSED!"
var FAILED = " FAILED! expected: ";

var	DEBUG =	false;









function TestCaseObject(l, n, d, e,	a )	{
	this.name		 = n;
	this.description = "Line( " + l + " ) : " + d;
	this.expect		 = e;
	this.actual		 = a;
	this.passed		 = true;
	this.reason		 = "";
	this.bugnumber	  =	BUGNUMBER;
	if(e === "error") {
		this.passed	= true;
		}
	else {
		this.passed	= getTestCaseResult( this.expect, this.actual );
		nTestsRun++;
		if( this.passed ) {
			nPassed++;
			}
		else {
			nFailed++;
			}
		}
}


























function startTest() {


























    testcases = new Array();
    tc = 0;
}





function AddTestCase( description, expect, actual ) {
    testcases[tc++] = new TestCaseObject(134, SECTION,description,expect,actual);
}

function test(toEval) {
    for ( tc=0; tc < testcases.length; tc++ ) {
		var oldResult = testcases[tc].passed;
		var reason = "";

        if(arguments.length != 0) { 
			try { testcases[tc].actual = eval( testcases[tc].actual ); }
			catch(e) { thmDecodeError(e); nRTE++; if(testcases[tc].expect === "error") testcases[tc].actual = "error"; }
			if(typeof(arguments[0]) == "string") {
				testcases[tc].reason += arguments[0];
				reason = arguments[0];
				}
			}
        testcases[tc].passed = writeTestCaseResult(
                            testcases[tc].expect,
                            testcases[tc].actual,
                            testcases[tc].description +" = "+ testcases[tc].actual + reason);
		if(oldResult != testcases[tc].passed) {
			if(oldResult) {
				nFailed++; nPassed--;
				}
			else {
				nFailed--; nPassed++;
				}
			}
    }
    stopTest();
    return ( testcases );
}





function getTestCaseResult(	expect,	actual ) {
	
	
		if ( actual	!= actual )	{
			if ( typeof	actual == "object" ) {
				actual = "NaN object";
			} else {
				actual = "NaN number";
			}
		}
		if ( expect	!= expect )	{
			if ( typeof	expect == "object" ) {
				expect = "NaN object";
			} else {
				expect = "NaN number";
			}
		}

		var	passed = ( expect == actual	) ?	true : false;

	
	
		if (	!passed
				&& typeof(actual) == "number"
				&& typeof(expect) == "number"
			) {
				if ( Math.abs(actual-expect) < 0.0000001 ) {
					passed = true;
				}
		}

	
		if ( typeof(expect)	!= typeof(actual) )	{
			passed = false;
		}

		return passed;
}








function writeTestCaseResult( expect, actual, string ) {
		var	passed = getTestCaseResult(	expect,	actual );
		writeFormattedResult( expect, actual, string, passed );
		return passed;
}
function writeFormattedResult( expect, actual, string, passed ) {
        var s = string ;
        s += ( passed ) ? PASSED : FAILED + expect;
        if( ! passed ) writeLineToLog( s);
        return passed;
}
function writeLineToLog( string	) {
	OutputMessage( string );
}
function writeHeaderToLog( string )	{
	OutputMessage( string );
}








function stopTest()	{
 	var gc;
	if ( gc != undefined ) {
		gc();
	}
}






function getFailedCases() {
  for (	var	i =	0; i < testcases.length; i++ ) {
	 if	( !	testcases[i].passed	) {
		OutputMessage( testcases[i].description	+" = " +testcases[i].actual	+" expected: "+	testcases[i].expect	);
	 }
  }
}
 



var	msPerDay =			86400000;
var	HoursPerDay	=		24;
var	MinutesPerHour =	60;
var	SecondsPerMinute =	60;
var	msPerSecond	=		1000;
var	msPerMinute	=		60000;		
var	msPerHour =			3600000;	
var             TZ_DIFF	= getTimeZoneDiff();  
var             TZ_PST = -8;  
var             PST_DIFF = TZ_DIFF - TZ_PST;  
var	TIME_1970	 = 0;
var	TIME_2000	 = 946684800000;
var	TIME_1900	 = -2208988800000;








function getTimeZoneDiff()
{
  return -((new Date(2000, 1, 1)).getTimezoneOffset())/60;
}






function adjustResultArray(ResultArray, msMode)
{
  
  if (!PST_DIFF) {return;} 

  











 
  if (msMode)
  {
    
    
    var t = ResultArray[TIME]  +  TZ_DIFF*msPerHour;

    
    ResultArray[HOURS] = HourFromTime(t); 
    ResultArray[DAY] = WeekDay(t);
    ResultArray[DATE] = DateFromTime(t);
    ResultArray[MONTH] = MonthFromTime(t);
    ResultArray[YEAR] = YearFromTime(t);  
  }
  else
  {
    
    
    var t = ResultArray[TIME]  -  PST_DIFF*msPerHour;

    
    ResultArray[TIME] = t;
    ResultArray[UTC_HOURS] = HourFromTime(t); 
    ResultArray[UTC_DAY] = WeekDay(t);
    ResultArray[UTC_DATE] = DateFromTime(t);
    ResultArray[UTC_MONTH] = MonthFromTime(t);
    ResultArray[UTC_YEAR] = YearFromTime(t);
  }
}


function Day( t	) {
	return ( Math.floor(t/msPerDay ) );
}
function DaysInYear( y ) {
	if ( y % 4 != 0	) {
		return 365;
	}
	if ( (y	% 4	== 0) && (y	% 100 != 0)	) {
		return 366;
	}
	if ( (y	% 100 == 0)	&&	(y % 400 !=	0) ) {
		return 365;
	}
	if ( (y	% 400 == 0)	){
		return 366;
	} else {
		return "ERROR: DaysInYear("	+ y	+ ") case not covered";
	}
}
function TimeInYear( y ) {
	return ( DaysInYear(y) * msPerDay );
}
function DayNumber(	t )	{
	return ( Math.floor( t / msPerDay )	);
}
function TimeWithinDay(	t )	{
	if ( t < 0 ) {
		return ( (t	% msPerDay)	+ msPerDay );
	} else {
		return ( t % msPerDay );
	}
}
function YearNumber( t ) {
}
function TimeFromYear( y ) {
	return ( msPerDay *	DayFromYear(y) );
}
function DayFromYear( y	) {
	return (	365*(y-1970) +
				Math.floor((y-1969)/4) -
				Math.floor((y-1901)/100) +
				Math.floor((y-1601)/400) );
}
function InLeapYear( t ) {
	if ( DaysInYear(YearFromTime(t)) ==	365	) {
		return 0;
	}
	if ( DaysInYear(YearFromTime(t)) ==	366	) {
		return 1;
	} else {
		return "ERROR:	DayFromYear("+y+") case	not	covered";
	}
}
function YearFromTime( t ) {
	t =	Number(	t );
	var	sign = ( t < 0 ) ? -1 :	1;
	var	year = ( sign <	0 )	? 1969 : 1970;
	for	(	var	timeToTimeZero = t;	;  ) {
	
		timeToTimeZero -= sign * TimeInYear(year)

	
		if ( sign <	0 )	{
			if ( sign *	timeToTimeZero <= 0	) {
				break;
			} else {
				year +=	sign;
			}
		} else {
			if ( sign *	timeToTimeZero < 0 ) {
				break;
			} else {
				year +=	sign;
			}
		}
	}
	return ( year );
}
function MonthFromTime(	t )	{
	
	var	day	= DayWithinYear( t );
	var	leap = InLeapYear(t);

	if ( (0	<= day)	&& (day	< 31) )	{
		return 0;
	}
	if ( (31 <=	day) &&	(day < (59+leap)) )	{
		return 1;
	}
	if ( ((59+leap)	<= day)	&& (day	< (90+leap)) ) {
		return 2;
	}
	if ( ((90+leap)	<= day)	&& (day	< (120+leap)) )	{
		return 3;
	}
	if ( ((120+leap) <=	day) &&	(day < (151+leap)) ) {
		return 4;
	}
	if ( ((151+leap) <=	day) &&	(day < (181+leap)) ) {
		return 5;
	}
	if ( ((181+leap) <=	day) &&	(day < (212+leap)) ) {
		return 6;
	}
	if ( ((212+leap) <=	day) &&	(day < (243+leap)) ) {
		return 7;
	}
	if ( ((243+leap) <=	day) &&	(day < (273+leap)) ) {
		return 8;
	}
	if ( ((273+leap) <=	day) &&	(day < (304+leap)) ) {
		return 9;
	}
	if ( ((304+leap) <=	day) &&	(day < (334+leap)) ) {
		return 10;
	}
	if ( ((334+leap) <=	day) &&	(day < (365+leap)) ) {
		return 11;
	} else {
		return "ERROR:	MonthFromTime("+t+") not known";
	}
}
function DayWithinYear(	t )	{
		return(	Day(t) - DayFromYear(YearFromTime(t)));
}
function DateFromTime( t ) {
	var	day	= DayWithinYear(t);
	var	month =	MonthFromTime(t);

	if ( month == 0	) {
		return ( day + 1 );
	}
	if ( month == 1	) {
		return ( day - 30 );
	}
	if ( month == 2	) {
		return ( day - 58 -	InLeapYear(t) );
	}
	if ( month == 3	) {
		return ( day - 89 -	InLeapYear(t));
	}
	if ( month == 4	) {
		return ( day - 119 - InLeapYear(t));
	}
	if ( month == 5	) {
		return ( day - 150-	InLeapYear(t));
	}
	if ( month == 6	) {
		return ( day - 180-	InLeapYear(t));
	}
	if ( month == 7	) {
		return ( day - 211-	InLeapYear(t));
	}
	if ( month == 8	) {
		return ( day - 242-	InLeapYear(t));
	}
	if ( month == 9	) {
		return ( day - 272-	InLeapYear(t));
	}
	if ( month == 10 ) {
		return ( day - 303-	InLeapYear(t));
	}
	if ( month == 11 ) {
		return ( day - 333-	InLeapYear(t));
	}

	return ("ERROR:	 DateFromTime("+t+") not known"	);
}
function WeekDay( t	) {
	var	weekday	= (Day(t)+4) % 7;
	return(	weekday	< 0	? 7	+ weekday :	weekday	);
}



function HourFromTime( t ) {
	var	h =	Math.floor(	t /	msPerHour )	% HoursPerDay;
	return ( (h<0) ? HoursPerDay + h : h  );
}
function MinFromTime( t	) {
	var	min	= Math.floor( t	/ msPerMinute )	% MinutesPerHour;
	return(	( min <	0 )	? MinutesPerHour + min : min  );
}
function SecFromTime( t	) {
	var	sec	= Math.floor( t	/ msPerSecond )	% SecondsPerMinute;
	return ( (sec <	0 )	? SecondsPerMinute + sec : sec );
}
function msFromTime( t ) {
	var	ms = t % msPerSecond;
	return ( (ms < 0 ) ? msPerSecond + ms :	ms );
}
function LocalTZA()	{
	return ( TZ_DIFF * msPerHour );
}
function UTC( t	) {
	return ( t - LocalTZA()	- DaylightSavingTA(t - LocalTZA()) );
}

function DaylightSavingTA( t ) {
	t =	t -	LocalTZA();

	var	dst_start =	GetFirstSundayInApril(t) + 2*msPerHour;
	var	dst_end	  =	GetLastSundayInOctober(t)+ 2*msPerHour;

	if ( t >= dst_start	&& t < dst_end ) {
		return msPerHour;
	} else {
		return 0;
	}

	
	

	OutputMessage( new Date( UTC(dst_start + LocalTZA())) );

	return UTC(dst_start  +	LocalTZA());
}
function GetFirstSundayInApril(	t )	{
	var	year = YearFromTime(t);
	var	leap = InLeapYear(t);

	var	april =	TimeFromYear(year) + TimeInMonth(0,	leap) +	TimeInMonth(1,leap)	+
	TimeInMonth(2,leap);

	for	( var first_sunday = april;	WeekDay(first_sunday) >	0;
		first_sunday +=	msPerDay )
	{
		;
	}

	return first_sunday;
}
function GetLastSundayInOctober( t ) {
	var	year = YearFromTime(t);
	var	leap = InLeapYear(t);

	for	( var oct =	TimeFromYear(year),	m =	0; m < 9; m++ )	{
		oct	+= TimeInMonth(m, leap);
	}
	for	( var last_sunday =	oct	+ 30*msPerDay; WeekDay(last_sunday)	> 0;
		last_sunday	-= msPerDay	)
	{
		;
	}
	return last_sunday;
}
function LocalTime(	t )	{
	return ( t + LocalTZA()	+ DaylightSavingTA(t) );
}
function MakeTime( hour, min, sec, ms )	{
	if ( isNaN(	hour ) || isNaN( min ) || isNaN( sec ) || isNaN( ms	) )	{
		return Number.NaN;
	}

	hour = ToInteger(hour);
	min	 = ToInteger( min);
	sec	 = ToInteger( sec);
	ms	 = ToInteger( ms );

	return(	(hour*msPerHour) + (min*msPerMinute) +
			(sec*msPerSecond) +	ms );
}
function MakeDay( year,	month, date	) {
	if ( isNaN(year) ||	isNaN(month) ||	isNaN(date)	) {
		return Number.NaN;
	}
	year = ToInteger(year);
	month =	ToInteger(month);
	date = ToInteger(date );

	var	sign = ( year <	1970 ) ? -1	: 1;
	var	t =	   ( year <	1970 ) ? 1 :  0;
	var	y =	   ( year <	1970 ) ? 1969 :	1970;

	var	result5	= year + Math.floor( month/12 );
	var	result6	= month	% 12;

	if ( year <	1970 ) {
	   for ( y = 1969; y >=	year; y	+= sign	) {
		 t += sign * TimeInYear(y);
	   }
	} else {
		for	( y	= 1970 ; y < year; y +=	sign ) {
			t += sign *	TimeInYear(y);
		}
	}

	var	leap = InLeapYear( t );

	for	( var m	= 0; m < month;	m++	) {
		t += TimeInMonth( m, leap );
	}

	if ( YearFromTime(t) !=	result5	) {
		return Number.NaN;
	}
	if ( MonthFromTime(t) != result6 ) {
		return Number.NaN;
	}
	if ( DateFromTime(t) !=	1 )	{
		return Number.NaN;
	}

	return ( (Day(t)) +	date - 1 );
}
function TimeInMonth( month, leap )	{
	
	
	

	if ( month == 3	|| month ==	5 || month == 8	|| month ==	10 ) {
		return ( 30*msPerDay );
	}

	
	if ( month == 0	|| month ==	2 || month == 4	|| month ==	6 ||
		 month == 7	|| month ==	9 || month == 11 ) {
		return ( 31*msPerDay );
	 }

	
	return ( (leap == 0) ? 28*msPerDay : 29*msPerDay );
}
function MakeDate( day,	time ) {
	if (	day	== Number.POSITIVE_INFINITY	||
			day	== Number.NEGATIVE_INFINITY	||
			day	== Number.NaN )	{
		return Number.NaN;
	}
	if (	time ==	Number.POSITIVE_INFINITY ||
			time ==	Number.POSITIVE_INFINITY ||
			day	== Number.NaN) {
		return Number.NaN;
	}
	return ( day * msPerDay	) +	time;
}
function TimeClip( t ) {
	if ( isNaN(	t )	) {
		return ( Number.NaN	);
	}
	if ( Math.abs( t ) > 8.64e15 ) {
		return ( Number.NaN	);
	}

	return ( ToInteger(	t )	);
}
function ToInteger(	t )	{
	t =	Number(	t );

	if ( isNaN(	t )	){
		return ( Number.NaN	);
	}
	if ( t == 0	|| t ==	-0 ||
		 t == Number.POSITIVE_INFINITY || t	== Number.NEGATIVE_INFINITY	) {
		 return	0;
	}

	var	sign = ( t < 0 ) ? -1 :	1;

	return ( sign *	Math.floor(	Math.abs( t	) )	);
}
function Enumerate ( o ) {
	var	p;
	for	( p	in o ) {
		OutputMessage( p +": " + o[p] );
	}
}



function GetContext() {
	return Packages.com.netscape.javascript.Context.getCurrentContext();
}
function OptLevel( i ) {
	i =	Number(i);
	var	cx = GetContext();
	cx.setOptimizationLevel(i);
}






































    var SECTION = "15.6.4.2-2";
    var VERSION = "ECMA_1";
    startTest();
    var TITLE   = "Boolean.prototype.toString()"
    writeHeaderToLog( SECTION + TITLE );

    var testcases = getTestCases();
    test();

function getTestCases() {
    var array = new Array();
    var item = 0;


    array[item++] = new 


TestCaseObject(54, SECTION,"tostr=Boolean.prototype.toString; x=new Boolean(); x.toString=tostr;x.toString()","false","tostr=Boolean.prototype.toString; x=new Boolean(); x.toString=tostr;x.toString()");
    array[item++] = new 


TestCaseObject(58, SECTION,"tostr=Boolean.prototype.toString; x=new Boolean(true); x.toString=tostr; x.toString()","true","tostr=Boolean.prototype.toString; x=new Boolean(true); x.toString=tostr; x.toString()");
    array[item++] = new 


TestCaseObject(62, SECTION,"tostr=Boolean.prototype.toString; x=new Boolean(false); x.toString=tostr;x.toString()","false","tostr=Boolean.prototype.toString; x=new Boolean(); x.toString=tostr;x.toString()");
    return ( array );

}
function test() {
    for ( tc=0; tc < testcases.length; tc++ ) {
        testcases[tc].actual = eval( testcases[tc].actual );

		var oldResult = testcases[tc].passed;

        testcases[tc].passed = writeTestCaseResult(
                            testcases[tc].expect,
                            testcases[tc].actual,
                            testcases[tc].description +" = "+
                            testcases[tc].actual );

		if(oldResult != testcases[tc].actual) {
			if(oldResult) {
				nFailed++; nPassed--;
				}
			else {
				nFailed--; nPassed++;
				}
			}

        testcases[tc].reason += ( testcases[tc].passed ) ? "" : "wrong value ";
    }
    stopTest();
    return ( testcases );
}FinalResult();







